import java.util.Arrays;

/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung. Es werden damit nur bestimmte
Spezialfälle geprüft. Liefern die Testklassen keinen Fehler, garantiert dies noch nicht die
Korrektheit Ihrer Lösung gemäß der Angabe.
*/
public class Aufgabe1 {

    /*
    Aufgabe: Manipulation von einfachen Arrays.

        Ergänzen Sie fehlende Teile dieser Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt. Es sollen keine zusätzlichen Methoden implementiert werden.
        Hinweis: Die beiden gefragten Methoden funktionieren ähnlich. Sie dürfen sich
        daher gegenseitig aufrufen, oder auch unabhängig implementiert werden.

    Punkte (maximal 20):
        10 Punkte für die Implementierung von 'dropLeftMutating',
        10 Punkte für die Implementierung von 'dropLeft'.
    */

    // Schreibt 'value' vor den ersten Eintrag (mit kleinstem Index) in 'array',
    // der größer oder gleich dem angegebenen Wert ist, spätestens aber an die
    // letzte Stelle (array.length-1).
    // (Ist der erste Eintrag bereits größer als 'value' passiert nichts.)
    // Alle Einträge bis zur Einfügeposition rücken ggfs. um eine Position
    // Richtung kleinerem Index um für den neuen Eintrag Platz zu machen.
    // Der Eintrag mit dem Index 0 geht in diesem Fall verloren.
    // Beachten Sie dazu die Beispiele in der Methode main (siehe unten).
    // Vorbedingung: array != null
    public static void dropLeftMutating(int[] array, int value) {
        // TODO: implementieren Sie die Methode.
        int[] help = new int[array.length];
        int count = 1;
        boolean check = false;

        if (array != null) {


            for (int i = 0; i < array.length - 1; i++) {
                if (value <= array[i]) {
                    help[i] = value;
                    check = true;
                }
                if (check == true) {
                    help[i] = array[i + 1];
                }
            }
            for (int i = 0; i < array.length; i++) {
                array[i] = help[i];

            }
        }
    }


    // Macht dasselbe wie dropLeftMutating mit dem Unterschied,
    // dass das angegebene Array nicht verändert wird. Stattdessen
    // wird das Ergebnis als neues Array zurückgeliefert;
    // liefert null, wenn null übergeben wird.
    public static int[] dropLeft(int[] array, int i) {
        // TODO: implementieren Sie die Methode.
        int[] help = new int[array.length];
        int count = 1;
        boolean check = false;

        if (array == null|| help== null) {
            return null;
        }


        for (int j = 0; j < array.length - 1; j++) {
            if (i <= array[j]) {
                help[j] = i;
                check = true;
            }
            if (check == true) {
                help[j] = array[j + 1];
            }
        }
        return array;

    }


    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        //Testen von dropLeftMutating:
        int[] array = new int[]{0, 1, 1, 4, 5};
        dropLeftMutating(array, 3);
        System.out.println(Arrays.toString(array)); //[1, 1, 3, 4, 5]

        array = new int[]{5};
        dropLeftMutating(array, 0);
        System.out.println(Arrays.toString(array)); //[5]

        array = new int[]{2};
        dropLeftMutating(array, 3);
        System.out.println(Arrays.toString(array)); //[3]

        array = new int[]{};
        dropLeftMutating(array, 3);
        System.out.println(Arrays.toString(array)); //[]

        //Testen von dropLeft:
        //...

    }
}

